Attribute VB_Name = "modGetMessageFont"
' MsgFnt95.Bas - Get the Win95 Message Box Font
' 95/07/08 Copyright 1995, Larry Rebich, The Bridge, Inc.
' 95/10/08 Work on this again
' 95/10/09 Chris Dias gives a helping hand

    Option Explicit
    DefLng A-Z
    
    Const SPI_GETNONCLIENTMETRICS = 41
    
    Const LF_FACESIZE = 32

    Type LOGFONT                    'font structure
        lfHeight As Long
        lfWidth As Long
        lfEscapement As Long
        lfOrientation As Long
        lfWeight As Long
        lfItalic As Byte
        lfUnderline As Byte
        lfStrikeOut As Byte
        lfCharSet As Byte
        lfOutPrecision As Byte
        lfClipPrecision As Byte
        lfQuality As Byte
        lfPitchAndFamily As Byte
        lfFaceName(1 To LF_FACESIZE) As Byte
    End Type

    Type NONCLIENTMETRICS           'non client metrics structure
        cbSize As Long              'size of this area
        iBorderWidth As Long
        iScrollWidth As Long
        iScrollHeight As Long
        iCaptionWidth As Long
        iCaptionHeight As Long
        lfCaptionFont As LOGFONT
        iSMCaptionWidth As Long
        iSMCaptionHeight As Long
        lfSMCaptionFont As LOGFONT
        iMenuWidth As Long
        iMenuHeight As Long
        lfMenuFont As LOGFONT
        lfStatusFont As LOGFONT
        lfMessageFont As LOGFONT
    End Type

Declare Function SystemParametersInfo Lib "User32" Alias "SystemParametersInfoA" _
        (ByVal uAction As Long, ByVal uParam As Long, lpvParam As Any, ByVal fuWinIni As Long) As Long

Function GetWin95MsgBoxFont(TheFontName As String, TheFontSize As Single, _
   TheFontBold As Integer, TheFontItalic As Integer, _
   TheFontStrikeThru As Integer, TheFontUnderline As Integer) As Integer
    
    Dim UserMetrics As NONCLIENTMETRICS 'declare user type
    Dim i As Integer                    'pointer
    Dim lRtn As Long                    'return from API call
    Dim sFontName As String             'work string

    UserMetrics.cbSize = Len(UserMetrics)   'set the size of the element
    lRtn = SystemParametersInfo(SPI_GETNONCLIENTMETRICS, 0&, UserMetrics, 0&)   'get it
    If lRtn <> 0 Then                   'if not zero then OK
        sFontName = StrConv(UserMetrics.lfMessageFont.lfFaceName(), vbUnicode)  'convert from Unicode
        i = InStr(sFontName, Chr$(0))   'dump trailing stuff
        If i > 0 Then                   'in case a 32 byte name
            sFontName = Left$(sFontName, i - 1) 'get just the name
        End If
        TheFontName = sFontName         'return it
        TheFontSize = Abs(UserMetrics.lfMessageFont.lfHeight * (48 / 64))   'return the font size

        TheFontBold = False             'set 'em off to start
        TheFontItalic = False
        TheFontStrikeThru = False
        TheFontUnderline = False
        
        If UserMetrics.lfMessageFont.lfWeight > 550 Then    '400 is normal, 700 is bold
            TheFontBold = True
        End If
    
        If CInt(UserMetrics.lfMessageFont.lfItalic) <> 0 Then       'any italic
            TheFontItalic = True
        End If
        
        If CInt(UserMetrics.lfMessageFont.lfStrikeOut) <> 0 Then    'any strike thru
            TheFontStrikeThru = True
        End If
        
        If CInt(UserMetrics.lfMessageFont.lfUnderline) <> 0 Then    'any underline
            TheFontUnderline = True
        End If
        
        GetWin95MsgBoxFont = True   'got it
    End If
End Function

